VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
END
Attribute VB_Name = "BaseExecutive"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
' John Robbins
' Microsoft Systems Journal - August, 1997
''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
' FILE          :   BaseExecutive.cls
' DESCRIPTION   :
'  The abstract base class for all debugger executives.
''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
Option Explicit

''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
' FUNCTION        :  DebugCreateProcess
' DISCUSSION      :
'  Called when the debugger thread gets a process create notification.
' PARAMETERS      :
'  clsDebugger - The debugger class to query for additional information.
'  dwProcessID - The process ID for the process.
'  dwThreadID  - The thread ID for the thread.
''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
Public Sub DebugCreateProcess(clsDebugger As DebuggerClass, _
                              dwProcessID As Long, _
                              dwThreadID As Long)
End Sub

''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
' FUNCTION        :  DebugExitProcess
' DISCUSSION      :
'  Called when the debugger thread gets a process exit notification.
' PARAMETERS      :
'  clsDebugger - The debugger class to query for additional information.
'  dwProcessID - The process ID for the process.
'  dwThreadID  - The thread ID for the thread.
''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
Public Sub DebugExitProcess(clsDebugger As DebuggerClass, _
                            dwProcessID As Long, _
                            dwThreadID As Long)
End Sub

''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
' FUNCTION        :  DebugCreateThread
' DISCUSSION      :
'  Called when the debugger thread gets a thread create notification.
' PARAMETERS      :
'  clsDebugger - The debugger class to query for additional information.
'  dwProcessID - The process ID for the process.
'  dwThreadID  - The thread ID for the thread.
''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
Public Sub DebugCreateThread(clsDebugger As DebuggerClass, _
                             dwProcessID As Long, _
                             dwThreadID As Long)
End Sub

''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
' FUNCTION        :  DebugExitThread
' DISCUSSION      :
'  Called when the debugger thread gets a thread exit notification.
' PARAMETERS      :
'  clsDebugger - The debugger class to query for additional information.
'  dwProcessID - The process ID for the process.
'  dwThreadID  - The thread ID for the thread.
''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
Public Sub DebugExitThread(clsDebugger As DebuggerClass, _
                           dwProcessID As Long, _
                           dwThreadID As Long)
End Sub

''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
' FUNCTION        :  DebugDllLoad
' DISCUSSION      :
'  Called when the debugger thread gets a DLL load notification.
' PARAMETERS      :
'  clsDebugger - The debugger class to query for additional information.
'  dwProcessID - The process ID for the process.
'  dwThreadID  - The thread ID for the thread.
''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
Public Sub DebugDllLoad(clsDebugger As DebuggerClass, _
                        dwProcessID As Long, _
                        dwThreadID As Long)
End Sub

''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
' FUNCTION        :  DebugDllUnload
' DISCUSSION      :
'  Called when the debugger thread gets a DLL unload notification.
' PARAMETERS      :
'  clsDebugger - The debugger class to query for additional information.
'  dwProcessID - The process ID for the process.
'  dwThreadID  - The thread ID for the thread.
''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
Public Sub DebugDllUnload(clsDebugger As DebuggerClass, _
                          dwProcessID As Long, _
                          dwThreadID As Long)
End Sub

''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
' FUNCTION        :  DebugODS
' DISCUSSION      :
'  Called when the debugger thread gets an OutputDebugString
'  notification
' PARAMETERS      :
'  clsDebugger - The debugger class to query for additional information.
'  dwProcessID - The process ID for the process.
'  dwThreadID  - The thread ID for the thread.
''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
Public Sub DebugODS(clsDebugger As DebuggerClass, _
                    dwProcessID As Long, _
                    dwThreadID As Long)
End Sub

''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
' FUNCTION        :  DebugException
' DISCUSSION      :
'  Called when the debugger thread gets an exception notification.
' PARAMETERS      :
'  clsDebugger - The debugger class to query for additional information.
'  dwContType  - The way to continue debugging.
'  dwProcessID - The process ID for the process.
'  dwThreadID  - The thread ID for the thread.
''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
Public Sub DebugException(clsDebugger As DebuggerClass, _
                          dwContType As Long, _
                          dwProcessID As Long, _
                          dwThreadID As Long)
End Sub

''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
' FUNCTION        :  DebugRipInfo
' DISCUSSION      :
'  Called when the debugger thread gets an RIP notification.
' PARAMETERS      :
'  clsDebugger - The debugger class to query for additional information.
'  dwProcessID - The process ID for the process.
'  dwThreadID  - The thread ID for the thread.
''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
Public Sub DebugRipInfo(clsDebugger As DebuggerClass, _
                        dwProcessID As Long, _
                        dwThreadID As Long)
End Sub

''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
' FUNCTION        :  PauseProcess
' DISCUSSION      :
'  When the debug process has been told to pause, this function is
'  called because it is up to the executive to do the SuspendThreads.
' PARAMETERS      :
'  None.
''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
Public Sub PauseProcess()
End Sub

''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
' FUNCTION        :  ResumeProcess
' DISCUSSION      :
'  When the debug process has been told to resume, this function is
'  called because it is up to the executive to do the ResumeThreads.
' PARAMETERS      :
'  None.
''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
Public Sub ResumeProcess()
End Sub


